<?php

/**------------------------------------------------
*
* Rooty, 2018 <rooty@rooty.me>
*
*
* This software is protected by copyright, please
* read the file COPYRIGHT.
* This program is distributed in the hope that it
* will be useful, but without any warranty; without
* even the implied warranty of merchantability or
* fitness for a particular purpose. Please
* read the file LICENCE.
*
* Fichier UserPreferenceManagerDb.php
*
*Ce fichier contient la classe UserPreferenceManagerDb
*
* @author Rooty <www.rooty.me|rooty@rooty.me>
* @link www.rooty.me
* @since 2004/04/14
* @version 0.3
* @package system_data
* @subpackage UserPreference
* @copyright Copyright &copy; 2004-2005, ARD Limousin
*/

#####################################################################################################
################################# Parametrage
#####################################################################################################
/**
* declaration du system... si cette variable n'est pas définie, les fichier inclus ne marche pas...
* cette variable est déclarée sur la page d'execution du script.
*<p> if ( !defined('SYSTEM_IN') )
* {
* die("Hacking attempt");
* }</p>
*/
if ( !defined('SYSTEM_IN') )
{
 die("Hacking attempt");
}

/**
* Classe UserPreferenceManagerDb
*
* classe de gestion des UserPreferences pour une do de données database (type gérés par database)<br><br>
* Sont configuré dans config_data_acces.php:<br>
* - La do d'information <br>
*    (actuellement seul DB possible->Pour ajouter une do reproduire NodeUserPreferenceManagerDb)<br>
* - Le Nom de la Table<br>
* - La configuration (Paramétrage des dos de do de données) est faite dans config_data_do.php<br>
* - La declaration de la connexion est faite à partir de config_system.php
*
* @package system_data
* @subpackage UserPreference
*/
class UserPreferenceManagerDb extends UserPreferenceManager
{

/**
* @var chaine
* @access private
* @desc ID de la UserPreference
*/
var $table		= "";

/**
* @var object
* @access private
* @desc objet database
*/
var $conn		= null;

	//
	// Constructor
	//

/**
* Constructeur de la classe UserPreferenceManagerDb PHP4
*
* <p>Initialise la UserPreferenceManagerDb</p>
* @access public
*/
	function UserPreferenceManagerDb()
	{
		$this->__construct();
	}

/**
* Constructeur de la classe UserPreferenceManagerDb PHP5
*
* <p>Initialise la UserPreferenceManagerDb</p>
* @access public
*/
	function __construct()
	{
		$this->setTable( DATA_ACCES_TABLE_USER_PREFERENCE );	/* Appel à la constant correspondant */
		$this->initSqlAttribut();				/* initialisation des noms de champs */
		$this->setConn($GLOBALS['SYSTEM_DATABASE_CONN']);
	}

/**
* getTable : recupere le nom de la table utilisée
* @access public
* @return chaine
*/
	function getTable()
	{
		return $this->table;
	}

/**
* setTable : recupere le nom de la table utilisée
* @access public
* @param chaine nom de la table
* @return chaine
*/
	function setTable($chaine)
	{
		if (!is_string($chaine))
			return false;

		$this->table=$chaine;
		return true;
	}

/**
* getTable : recupere le nom de la table utilisée
* @access public
* @return chaine
*/
	function getConn()
	{
		return $this->conn;
	}

/**
* setTable : recupere le nom de la table utilisée
* @access public
* @param object objet classe "database"
* @return chaine
*/
	function setConn(&$obj)
	{
		if (!is_object($obj))
			return false;

		$this->conn=&$obj;
		return true;
	}

/**
* doLoadFromId: Charge la UserPreference depuis la BD
*
* <p>Retourne un tableau contenant les infos de l'objets
* </p>
* @access public
* @param entier identifiant de l'association UserPreference
* @return tableau
*/
	function doLoadFromId($id)
	{
		$sql="SELECT * FROM ".$this->getTable()." WHERE ".$this->getSqlName("id")."=".$id;

		# Requete
		$tab=array();
		$result=$this->conn->sql_query($sql);

		if ($this->conn->sql_numrows()!=0)
		{
			$tab=$this->conn->sql_fetchrow();
			$tab=$this->translateArray($tab);
		}

		# Destruction des éléments
		$this->conn->sql_freeresult();					# Libération Mémoire
		return $tab;
	}

/**
* doInsert: Insert la UserPreference dans la BD
*
* <P>Insertion dans la Bd</P>
* @param entier identifiant de l'utilisateur
* @param entier identifiant du groupe
* @access public
* @return entier
*/
	function doInsert($langueId, $entryNodeId, $rightId)
	{
		$sql="INSERT INTO ".$this->getTable()." ("
			.$this->getSqlName("langue_id").", "
			.$this->getSqlName("entry_node_id").", "
			.$this->getSqlName("right_id").") VALUES (";
			$sql.="".$langueId.", ".$entryNodeId.", ".$rightId.")";

		# Requete
		$result=$this->conn->sql_query($sql);

		if ($this->conn->sql_affectedrows()==0)
		{
			$systemError=1;
			$classe="UserPreference";
			$message="Erreur dans UserPreferenceManagerDb";
			addError($systemError,$classe,$message, __line__, __file__);
			return 0;
		}
		$retour=$this->conn->sql_nextid();
		return $retour;
	}

/**
* doUpdate:Modifie la UserPreference dans la BD
*
* <P>Mise à jour de la UserPreference</P>
* @param entier identifiant de l'association
* @param entier identifiant de l'utilisateur
* @param entier identifiant du groupe
* @access public
* @return booleen
*/
	function doUpdate($id, $langueId, $entryNodeId, $rightId)
	{
		$sql="UPDATE ".$this->getTable()." SET "
			.$this->getSqlName("langue_id")."=".$langueId.", "
			.$this->getSqlName("entry_node_id")."=".$entryNodeId.", "
			.$this->getSqlName("right_id")."=".$rightId." WHERE ";
			$sql.=$this->getSqlName("id")."=".$id;

		# Requete
		$result=$this->conn->sql_query($sql);
		$retour=$id;
		return $retour;
	}

/**
* doDelete : Detruit le UserPreference dans la BD
*
* @param entier identifiant
* @access public
* @return booleen
*/
	function doDelete($id)
	{
		$sql="DELETE FROM ".$this->getTable()." WHERE ".$this->getSqlName("id")."=".$id;

		# Requete
		$result=$this->conn->sql_query($sql);

		if ($this->conn->sql_affectedrows()==0)
		{
			$systemError=1;
			$classe="UserPreference";
			$message="Erreur de SUPPRESSION dans UserPreferenceManagerDb";
			addError($systemError,$classe,$message, __line__, __file__);
			return false;
		}
		return true;
	}

	//////////////////////////////////////////////////////////////////////////
	//
	// Utilitaires pour la gestion des compatibilités BD
	//
	/////////////////////////////////////////////////////////////////////////
/**
* translateKey : change les cles du tableau resultant d'une requete en tableau de données pour l'objet
*
* <p>Supprime le nom de la table dans les noms de champs renvoyés par la BD<br/>
* garde la compatibilité avec les version précédentes</p>
* @param array tableau sql
* @access private
* @return array tableau des attributs
*/
	function translateArray($sqlArray)
	{
		/* Cas nouvelle BD systeme */
		$result["id"]				=$sqlArray[$this->getSqlName('user_preference_id')];
		$result["langue_id"]			=$sqlArray[$this->getSqlName("langue_id")];
		$result["entry_node_id"]		=$sqlArray[$this->getSqlName("entry_node_id")];
		$result["right_id"]			=$sqlArray[$this->getSqlName("right_id")];
		return $result;
	}

/**
* initSqlAttributName : recupere le nom d'un attribut a partir d'une cle
*
* <p>En fonction de la version sql, on trouvera ici la correspondance entre le nom attribut de l'objet et son nom en BD<br/>
* cette methode permet de garder la compatibilité avec les version précédentes</p>
* @param chaine nom de l'attribut recherche
* @access private
* @return booleen
*/
	function initSqlAttribut()
	{
		if(defined('DATA_ACCES_TABLE_VERSION'))
		{
			if( DATA_ACCES_TABLE_VERSION == 1)
			{
				$this->sqlAttributArray["id"]				="user_preference_id";
				$this->sqlAttributArray["langue_id"]			="langue_id";
				$this->sqlAttributArray["entry_node_id"]		="entry_node_id";
				$this->sqlAttributArray["right_id"]			="right_id";
				return true;
			}
		}
		$this->sqlAttributArray["id"]				="id";
		$this->sqlAttributArray["langue_id"]			="langue_id";
		$this->sqlAttributArray["entry_node_id"]		="entry_node_id";
		$this->sqlAttributArray["right_id"]			="right_id";
		return true;
	}

/**
* getSqlName : recupere le nom du champ a partir d'une cle
*
* <p>En fonction de la version sql, on trouvera ici la correspondance entre le nom attribut de l'objet et son nom en BD<br/>
* Cette methode permet de garder la compatibilite avec les version précédentes<br/>
* Elle s'appuie sur le tableau associatif $this->sqlAttributArray genere par initSqlAttributArray</p>
* @param chaine nom de l'attribut recherche
* @access private
* @return chaine nom du champ sql
*/
	function getSqlName($attribut)
	{
		return ( (isset($this->sqlAttributArray[$attribut]))?$this->sqlAttributArray[$attribut]:$attribut );
	}
}
?>
